// screen size
#define SCRN_WIDTH 640
#define SCRN_HEIGHT 480

// VGA definitions
#define VGA_BASE_PIN 16
#define VGA_VSYNC_PIN (VGA_BASE_PIN + 4)

// enough room for a scanline at full colour bit depth
#define LINEBUFSIZE (1920*4)

// RGBI8 colortable with full luminance
#define ORANGE	0b000_11111
#define BLUE	0b001_11111
#define	GREEN	0b010_11111
#define	CYAN	0b011_11111
#define RED		0b100_11111
#define	MAGENTA	0b101_11111
#define	YELLOW	0b110_11111
#define	WHITE	0b111_11111
#define	BLACK	0

// the video object
struct __using("video/p2videodrv.spin2") vid;

// space for video driver display and region info
int display1[14];
int first[14];

// the actual frame and line buffer
char frameBuffer[SCRN_WIDTH*SCRN_HEIGHT];
int lineBuffer[LINEBUFSIZE];

// Declare Prototypes
void Setup_Video();
void plot(int x, int y, int color);
void clearscreen (int color);
void line( int x0, int y0, int x1, int y1,int color);
void fillCircle(void *screen, int width, int xc, int yc, int r, int colour, int bpp);
void horizLine(void *buf, int width, int x1, int y1, int x2,int y2, int c, int bpp);
